diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 00000000..f8c600eb
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,16 @@
+[Unit]
+Description=Hive local web UI
+After=default.target
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+# HIVE_WEB_ENVIRONMENT
+ExecStart=%h/.local/bin/hive web --bind 127.0.0.1 --port 4567
+Restart=on-failure
+RestartSec=10
+
+[Install]
+WantedBy=default.target
diff --git a/install.sh b/install.sh
index bd8f6e2d..3304bba6 100755
--- a/install.sh
+++ b/install.sh
@@ -304,76 +304,19 @@ qmd_install_enabled() {
   esac
 }
 
-qmd_repair_hint() {
-  local qmd_home_arg="$1"
-  printf 'rerun hive update, or run: npm install --global --prefix %q %q' "$qmd_home_arg" "$QMD_NPM_PACKAGE"
-}
-
-# Install the qmd CLI used by Hive-managed llm-wiki refresh scripts into
-# Hive's own data prefix. This keeps the native better-sqlite3 build out
-# of the user's global npm prefix while still making `qmd` available from
-# the same bin directory as `hive`.
+# The installed CLI owns the qmd bootstrap. Keeping this shell wrapper thin
+# prevents installer/setup drift in prefix selection, native rebuild handling,
+# linking, and rollback behavior.
 install_qmd() {
-  local qmd_home qmd_bin qmd_link existing_qmd_link managed_qmd_link active_qmd active_qmd_canon managed_qmd_canon qmd_version
-  qmd_home="${data_home}/qmd"
-  qmd_bin="${qmd_home}/bin/qmd"
-  qmd_link="${bin_home}/qmd"
-
   if ! qmd_install_enabled; then
     log "qmd: skipped (HIVE_INSTALL_QMD=${INSTALL_QMD})"
     return 0
   fi
 
-  if ! command -v npm >/dev/null 2>&1; then
-    warn "missing wiki dependency 'npm'; qmd was not installed — install Node.js/npm and rerun hive update"
-    return 0
-  fi
-
-  log "qmd: installing ${QMD_NPM_PACKAGE} into ${qmd_home}"
-  mkdir -p "$qmd_home"
-  if ! npm install --global --prefix "$qmd_home" --no-audit --no-fund "$QMD_NPM_PACKAGE"; then
-    warn "qmd install failed; $(qmd_repair_hint "$qmd_home")"
-    return 0
-  fi
-
-  # `npm install` may leave an existing native better-sqlite3 build in place
-  # after a Node upgrade. Rebuild explicitly so `hive update` repairs the
-  # NODE_MODULE_VERSION mismatch class of failures.
-  npm rebuild --global --prefix "$qmd_home" better-sqlite3 >/dev/null 2>&1 || true
-
-  if [[ ! -x "$qmd_bin" ]]; then
-    warn "qmd install completed but no executable was found at ${qmd_bin}; $(qmd_repair_hint "$qmd_home")"
-    return 0
-  fi
-
-  if ! "$qmd_bin" --version >/dev/null 2>&1; then
-    warn "qmd installed at ${qmd_bin} but failed to start; $(qmd_repair_hint "$qmd_home")"
-    return 0
-  fi
-
-  if [[ -e "$qmd_link" || -L "$qmd_link" ]]; then
-    existing_qmd_link="$(readlink -f "$qmd_link" 2>/dev/null || true)"
-    managed_qmd_link="$(readlink -f "$qmd_bin" 2>/dev/null || echo "$qmd_bin")"
-    if [[ "$existing_qmd_link" != "$managed_qmd_link" ]]; then
-      warn "existing qmd at ${qmd_link}; leaving it unchanged (Hive-managed qmd is ${qmd_bin})"
-    else
-      ln -sfn "$qmd_bin" "$qmd_link"
-    fi
-  else
-    ln -sfn "$qmd_bin" "$qmd_link"
-  fi
-
-  active_qmd="$(command -v qmd 2>/dev/null || true)"
-  if [[ -n "$active_qmd" ]]; then
-    active_qmd_canon="$(readlink -f "$active_qmd" 2>/dev/null || true)"
-    managed_qmd_canon="$(readlink -f "$qmd_bin" 2>/dev/null || echo "$qmd_bin")"
-    if [[ -n "$active_qmd_canon" && "$active_qmd_canon" != "$managed_qmd_canon" ]]; then
-      warn "PATH resolves qmd to ${active_qmd}, not Hive-managed ${qmd_bin}; wiki refreshes may use the earlier binary"
-    fi
-  fi
-
-  qmd_version="$("$qmd_bin" --version 2>/dev/null || true)"
-  log "qmd: installed ${qmd_version:-${QMD_NPM_PACKAGE}}"
+  log "qmd: provisioning through hive setup --only=qmd"
+  HIVE_QMD_NPM_PACKAGE="$QMD_NPM_PACKAGE" \
+    XDG_DATA_HOME="$data_base" XDG_BIN_HOME="$bin_home" \
+    "$installed_bin" setup --only=qmd || die "qmd bootstrap failed; fix npm/Node and rerun hive update"
 }
 
 platform="$(detect_platform)"
@@ -409,9 +352,7 @@ if [[ "$DRY_RUN" -eq 1 ]]; then
   log "dry run: would gem install --install-dir ${gem_home} ${gem_file}"
   log "dry run: would run ${link_path} daemon install to enable daemon autostart"
   if qmd_install_enabled; then
-    log "dry run: would npm install --global --prefix ${data_home}/qmd ${QMD_NPM_PACKAGE}"
-    log "dry run: would npm rebuild --global --prefix ${data_home}/qmd better-sqlite3"
-    log "dry run: would link ${bin_home}/qmd"
+    log "dry run: would run ${installed_bin} setup --only=qmd"
   else
     log "dry run: would skip qmd install (HIVE_INSTALL_QMD=${INSTALL_QMD})"
   fi
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..429c4f4d 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -30,6 +30,9 @@ module Hive
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
       "hive-daemon-install" => 1,
+      "hive-web-service-status" => 1,
+      "hive-web-service-action" => 1,
+      "hive-setup" => 1,
       # Read-only inspection of the daemon's dispatch-request queue
       # (`hive daemon queue [list|show|prune]`). See AN-1/2/3 and
       # `Hive::Commands::Daemon#queue_command`.
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..787e21a7 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -149,6 +149,23 @@ module Hive
       ).call
     end
 
+    desc "setup [PROJECT]", "Validate and provision native Hive web, project enrollment, and per-user services"
+    option :diagnose_only, type: :boolean, default: false, desc: "report prerequisites without writing files or starting services"
+    option :force, type: :boolean, default: false, desc: "repair drifted service definitions (backs up customized units)"
+    option :service, type: :boolean, default: true, desc: "install and start managed daemon and web services"
+    option :only, type: :string, desc: "provision one Hive-owned component (qmd)"
+    def setup(project_path = Dir.pwd)
+      require "hive/commands/setup"
+      exit Hive::Commands::Setup.new(
+        project_path,
+        diagnose_only: options[:diagnose_only],
+        json: options[:json],
+        force: options[:force],
+        service: options[:service],
+        only: options[:only]
+      ).call
+    end
+
     desc "forget NAME", "Remove a project from the global registry (inverse of `hive init`)"
     long_desc <<~DESC
       Drops the entry whose `name` matches NAME from the global registry
@@ -1332,11 +1349,13 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "web [ACTION]", "Run the foreground web UI or manage its per-user service"
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
+    option :force, type: :boolean, default: false, desc: "overwrite a drifted managed service definition (install only)"
+    option :unsafe_no_auth, type: :boolean, default: false, desc: "allow a non-loopback listener without GitHub owner auth"
+    def web(action = nil)
+      if options[:json] && action.nil?
         require "json"
         message = "hive web has no JSON output (it runs a long-lived server). " \
                   "Use 'hive status --json' for machine-readable task data."
@@ -1355,7 +1374,9 @@ module Hive
       end
 
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      kwargs = { bind: options[:bind], port: options[:port] }
+      kwargs.merge!(action: action, force: options[:force], unsafe_no_auth: options[:unsafe_no_auth], json: options[:json]) if action
+      Hive::Commands::Web.new(**kwargs).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b..1a750406 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -1,6 +1,8 @@
 require "fileutils"
 require "json"
+require "open3"
 require "time"
+require "timeout"
 require "yaml"
 require "hive/config"
 require "hive/paths"
@@ -99,6 +101,69 @@ module Hive
         @log_file ||= File.join(@hive_home, "logs", "daemon.log")
       end
 
+      # Structured, side-effect-free daemon health snapshot.  The CLI emits
+      # this object for `daemon status --json`; the Rails status card consumes
+      # the same return value rather than redirecting global stdout inside a
+      # multi-threaded Puma process.
+      def status_payload
+        running = false
+        pid = nil
+        uptime_sec = nil
+        payload = nil
+
+        if File.exist?(pid_file)
+          payload = read_pid_file_payload
+          pid = payload && payload["pid"]
+          if pid && pid > 0 && pid_alive?(pid) && pid_owned_by_us?(payload, pid)
+            running = true
+            stat = File.stat(pid_file)
+            uptime_sec = (Time.now - stat.mtime).to_i
+          end
+        end
+
+        service_state = probe_service_state
+        {
+          "schema" => "hive-daemon-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
+          "ok" => true,
+          "running" => running,
+          "pid" => running ? pid : nil,
+          "uptime_sec" => uptime_sec,
+          "pid_file" => pid_file,
+          "log_file" => log_file,
+          "service_installed" => service_state["service_installed"],
+          "service_enabled" => service_state["service_enabled"],
+          "unit_path" => service_state["unit_path"],
+          "configured_executable" => service_state["configured_executable"],
+          "current_executable" => current_binary_path,
+          "configured_version" => service_state["configured_version"],
+          "running_executable" => running ? payload&.fetch("executable", nil) : nil,
+          "running_version" => running ? payload&.fetch("version", nil) : nil,
+          "drift" => daemon_drift(service_state, payload, running),
+          "observed_at" => Time.now.utc.iso8601,
+          "recommended_action" => daemon_recommendation(service_state, payload, running),
+          # Version of the querying CLI, retained for backward compatibility.
+          "current_version" => Hive::VERSION,
+          "update_nudge" => update_nudge_payload
+        }
+      end
+
+      # Programmatic enrollment API used by setup. It shares the exact
+      # validation and surgical write path with `hive daemon enable`, but
+      # returns data instead of printing so a setup JSON envelope remains one
+      # document on stdout.
+      def enrollment_results(enabled:)
+        targets = resolve_enable_targets
+        preflight_targets(targets)
+        targets.map do |entry|
+          path = File.join(entry["hive_state_path"], "config.yml")
+          previous = current_daemon_enabled(path)
+          write_daemon_block(path, enabled)
+          { "name" => entry["name"], "path" => entry["path"],
+            "previous" => previous, "current" => enabled, "config_yml" => path }
+        end
+      end
+
       private
 
       def start_daemon
@@ -141,7 +206,10 @@ module Hive
         # Write the PID file as YAML with process_start_time so `stop`
         # can detect PID reuse before sending TERM/KILL to a random
         # process that happens to have the same PID. PR-40 review P2 #3.
-        File.write(pid_file, pid_file_payload(Process.pid, own_start_time).to_yaml)
+        File.write(
+          pid_file,
+          pid_file_payload(Process.pid, own_start_time, executable: current_binary_path, version: Hive::VERSION).to_yaml
+        )
 
         # Load the daemon block from ~/Dev/hive/config.yml so operator
         # overrides (max_concurrent_runs, poll_interval_sec, log paths,
@@ -355,46 +423,17 @@ module Hive
       end
 
       def status_daemon
-        running = false
-        pid = nil
-        uptime_sec = nil
-
-        if File.exist?(pid_file)
-          payload = read_pid_file_payload
-          pid = payload && payload["pid"]
-          if pid && pid > 0 && pid_alive?(pid) && pid_owned_by_us?(payload, pid)
-            running = true
-            stat = File.stat(pid_file)
-            uptime_sec = (Time.now - stat.mtime).to_i
-          end
-        end
+        result = status_payload
 
         if @json
-          service_state = probe_service_state
-          puts JSON.generate(
-            "schema" => "hive-daemon-status",
-            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
-            "ok" => true,
-            "running" => running,
-            "pid" => running ? pid : nil,
-            "uptime_sec" => uptime_sec,
-            "pid_file" => pid_file,
-            "log_file" => log_file,
-            "service_installed" => service_state["service_installed"],
-            "service_enabled" => service_state["service_enabled"],
-            "unit_path" => service_state["unit_path"],
-            # Agent-native parity with the TUI footer / bot push: expose the
-            # update nudge so a programmatic caller can detect "behind" too.
-            "current_version" => Hive::VERSION,
-            "update_nudge" => update_nudge_payload
-          )
-        elsif running
-          puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s)"
+          puts JSON.generate(result)
+        elsif result.fetch("running")
+          puts "hive daemon: running (pid #{result.fetch('pid')}, uptime #{result.fetch('uptime_sec')}s)"
         else
           puts "hive daemon: not running"
         end
         # Exit code: 0 for running, 1 for not running (per plan U8)
-        raise Hive::Error, "daemon not running" unless running
+        raise Hive::Error, "daemon not running" unless result.fetch("running")
       end
 
       # Read-only autostart-state snapshot for the status envelope. A status
@@ -404,9 +443,51 @@ module Hive
       # out of the whole command.
       def probe_service_state
         require "hive/commands/daemon/service_installer"
-        Hive::Commands::Daemon::ServiceInstaller.new.service_state
+        installer = Hive::Commands::Daemon::ServiceInstaller.new
+        state = installer.service_state
+        executable = installer.configured_executable if installer.respond_to?(:configured_executable)
+        state.merge(
+          "configured_executable" => executable,
+          "configured_version" => probe_binary_version(executable)
+        )
       rescue StandardError
-        { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
+        { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil,
+          "configured_executable" => nil, "configured_version" => nil }
+      end
+
+      def probe_binary_version(binary)
+        return nil if binary.to_s.empty?
+
+        out, _err, status = Timeout.timeout(5) { Open3.capture3(binary, "--version") }
+        return nil unless status.success?
+
+        out[/\d+\.\d+\.\d+/]
+      rescue StandardError
+        nil
+      end
+
+      def daemon_drift(service_state, payload, running)
+        return "not_applicable" if service_state["service_installed"] == false
+        configured = service_state["configured_executable"]
+        current = current_binary_path
+        return "unknown" if configured.to_s.empty? || current.to_s.empty?
+        return "path" unless File.expand_path(configured) == File.expand_path(current)
+        return "version" if service_state["configured_version"] && service_state["configured_version"] != Hive::VERSION
+        return "version" if running && payload&.fetch("version", nil) && payload["version"] != Hive::VERSION
+
+        "none"
+      rescue ArgumentError
+        "unparseable"
+      end
+
+      def daemon_recommendation(service_state, payload, running)
+        drift = daemon_drift(service_state, payload, running)
+        case drift
+        when "none" then nil
+        when "not_applicable" then "hive daemon install"
+        when "path", "version", "unparseable" then "hive daemon install --force"
+        else "hive daemon status --json"
+        end
       end
 
       # The daemon-written update nudge, as a plain Hash for the status
@@ -713,17 +794,7 @@ module Hive
       # mirrors Forget / Prune / Status / etc.
       def do_call
         enabled = (@subcommand == "enable")
-        targets = resolve_enable_targets
-        # Pre-flight: validate every target up front so `--all` can't
-        # leave the registry half-flipped on a bad project mid-loop.
-        preflight_targets(targets)
-        results = targets.map do |entry|
-          path = File.join(entry["hive_state_path"], "config.yml")
-          previous = current_daemon_enabled(path)
-          write_daemon_block(path, enabled)
-          { "name" => entry["name"], "path" => entry["path"],
-            "previous" => previous, "current" => enabled, "config_yml" => path }
-        end
+        results = enrollment_results(enabled: enabled)
 
         if @json
           puts JSON.generate(
diff --git a/lib/hive/commands/init.rb b/lib/hive/commands/init.rb
index 7a13eb00..bd2166d9 100644
--- a/lib/hive/commands/init.rb
+++ b/lib/hive/commands/init.rb
@@ -75,7 +75,8 @@ module Hive
       CUSTOM_WORKFLOW_HINT_MESSAGE = "custom workflows live in this project — author one with `#{CUSTOM_WORKFLOW_HINT_COMMAND}`".freeze
 
       def initialize(project_path, force: false, json: false, prompts: nil,
-                     workflow: nil, new_workflow: nil, workflow_input: $stdin, workflow_output: $stderr)
+                     workflow: nil, new_workflow: nil, workflow_input: $stdin, workflow_output: $stderr,
+                     install_daemon_service: true)
         @project_path = File.expand_path(project_path)
         @force = force
         @json = json
@@ -83,6 +84,7 @@ module Hive
         @new_workflow = new_workflow
         @workflow_input = workflow_input
         @workflow_output = workflow_output
+        @install_daemon_service = install_daemon_service
         # Optional Prompts instance for testability. Tests inject a
         # pre-fed StringIO-backed instance to drive the interactive flow
         # without touching $stdin. Production keeps this nil so the
@@ -143,7 +145,7 @@ module Hive
         else
           print_summary(entry: entry, ops: ops, answers: answers, workflow: workflow_choice.descriptor.id)
         end
-        register_daemon_service!(autostart: answers.fetch("daemon_autostart", false))
+        register_daemon_service!(autostart: answers.fetch("daemon_autostart", false)) if @install_daemon_service
         run_init_preflight!
       rescue Hive::Commands::Init::Prompts::Aborted => e
         # The interactive WORKFLOW prompt (resolve_workflow_choice, which runs
@@ -183,7 +185,7 @@ module Hive
         else
           print_summary(entry: entry, ops: ops, answers: answers, workflow: id, scaffold_paths: paths)
         end
-        register_daemon_service!(autostart: answers.fetch("daemon_autostart", false))
+        register_daemon_service!(autostart: answers.fetch("daemon_autostart", false)) if @install_daemon_service
         run_init_preflight!
       end
 
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba76..ad699f2c 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -81,6 +81,76 @@ module Hive
           }
         end
 
+        # Best-effort identity read from a managed definition. This is a
+        # diagnostic only; lifecycle operations still resolve the current
+        # invoked binary instead of executing text parsed from a unit.
+        def configured_executable
+          return nil unless target_path && File.file?(target_path)
+
+          content = File.read(target_path)
+          raw = content[/^Environment=HIVE_BIN=([^\n]+)$/, 1] || content[/^ExecStart=([^\s]+)/, 1]
+          return Shellwords.shellsplit(raw).first if raw
+
+          # launchd has no ExecStart equivalent: its first
+          # ProgramArguments string is the invoked binary. Read only that
+          # narrowly scoped field and unescape XML rather than treating a
+          # plist as shell input.
+          arguments_xml = content[/<key>ProgramArguments<\/key>\s*<array>(.*?)<\/array>/m, 1]
+          arguments = arguments_xml.to_s.scan(%r{<string>([^<]+)</string>}).flatten.map { |value| CGI.unescapeHTML(value) }
+          # Hive's launchd definition wraps the target in `/bin/sh -c` to
+          # prevent an absent binary from creating a respawn storm. In that
+          # shape $0 (the fourth ProgramArguments entry) is the real Hive
+          # executable; ordinary launchd definitions use the first entry.
+          arguments[0] == "/bin/sh" && arguments[1] == "-c" ? arguments[3] : arguments.first
+        rescue ArgumentError, SystemCallError
+          nil
+        end
+
+        # Lifecycle controls deliberately remain separate from install: web
+        # and daemon are independent services, and status must never create or
+        # enable a unit as a side effect. Subclasses inherit these argv-only
+        # manager calls without teaching callers platform-specific commands.
+        def lifecycle_status
+          state = service_state
+          status =
+            if state["service_installed"] == false
+              "not_installed"
+            elsif service_running?
+              "running"
+            else
+              "stopped"
+            end
+          state.merge("status" => status)
+        rescue StandardError
+          { "platform" => envelope_platform, "unit_path" => target_path,
+            "service_installed" => nil, "service_enabled" => nil, "status" => "manager_unavailable" }
+        end
+
+        def control!(action)
+          action = action.to_s
+          raise ArgumentError, "unsupported service action #{action.inspect}" unless %w[start stop restart].include?(action)
+          return false unless target_path && File.exist?(target_path)
+
+          case platform
+          when :linux
+            return false unless systemctl_available?
+
+            !!@runner.call([ "systemctl", "--user", action, service_name ])
+          when :macos
+            return false unless launchctl_available?
+
+            if action == "restart"
+              !!@runner.call([ "launchctl", "unload", target_path ]) && !!@runner.call([ "launchctl", "load", target_path ])
+            elsif action == "start"
+              !!@runner.call([ "launchctl", "load", target_path ])
+            else
+              !!@runner.call([ "launchctl", "unload", target_path ])
+            end
+          else
+            false
+          end
+        end
+
         # launchd plist Label for this service. Matches the `<key>Label</key>`
         # value in the bundled plists (local.hive-daemon / local.hive-bot).
         def launchd_label
@@ -393,6 +463,17 @@ module Hive
           end
         end
 
+        def service_running?
+          case platform
+          when :linux
+            systemctl_available? && !!@runner.call([ "systemctl", "--user", "is-active", "--quiet", service_name ])
+          when :macos
+            launchctl_available? && !!@runner.call([ "launchctl", "list", launchd_label ])
+          else
+            false
+          end
+        end
+
         # Mirror systemctl_available? for macOS: distinguish "launchctl
         # missing" from "launchctl ran". launchd is effectively always
         # present on macOS, but without this guard a probe that could not
